package uk.ac.reading.sis05kol.mooc;
/*
My favourite game on the CBM Pet was Space Invaders. On the Pet it was a good clone of the Atari
Arcade game. At the time, circa 1977, I thought that it would be a good exercise to program
the game "one day".

I joined the University of Reading Begin "Programming: Build Your First Mobile Game" course and
thought that the basic canvas supplied to provide a foundation for Space Invaders.

About 40 programming hours later this was the result.

It still needs startup splash, rollover from the base level to new levels, tidy finish to the game
and "High Score" stuff.

I based the game on a Youtube video of Atari live game play. It is intended visually and audibly
to be a close clone.

This set of files should compile under Android Studio. I run it on an emulator
Nexus 5X API 26 Android 8.0 X86, it runs in landscape mode. It also runs fine on a Samsung Galaxy 5,
Sony Xperia Z, and Sony Xperia XZ

Andrew Chisholm

 */
// The Game - Invaders V0-7 - Date: 20150405
// The Game - Invaders V0-8 - Date: 20150405-2
// The Game - Invaders V0-9 - Date: 20150405-3 Bombs falling and number related to score
// The Game - Invaders V0-10 - Date: 20150406 Forts can be hit by the turret and by invaders, they
//                                            disintegrate gradually
// The Game - Invaders V0-11 - Date: 20150406-2 Targets are now 2D - this reduces the chance of a
//                                            miss and velocity of shells and bombs can be increased
// The Game - Invaders V0-12 - Date: 20150407 Fixed 4 - Added Saucer and made animations
// The Game - Invaders V0-13 - Date: 20150408 Added Saucer bangs
// The Game - Invaders V0-14 - Date: 20150415 Added sounds, exploding saucer, fixed some collision
//                                            grid bugs relating to the saucer and the sprites
// The Game - Invaders V0-15 - Date: 20150416 Added motion to the turret; it can now be operated
//                                            (right<>left) by sliding the finger
// The Game - Invaders V0-16 - Date: 20150419 Added Scores and score labels, number of lives,
//                                            number of life turrets, bonus life for 1000 points
//
//

/*
    Open Issues
3/ Sometimes a bang remains and is not cleared up - typically a top left corner. Looks like an
   array bounds issue
4/ Some bombs don't animate. An index had not been updated to [i] only the [0] was animating - Fixed
5/ Sometimes the turret doesn't seem to fire. It is firing but the shell doesn't get beyond the
   turret position - This seems to happen when the game restarts itself - this is not a valid
   condition

    Things to do
2/  Add Turret to collision grid
5/  Blow up turret
6/  Make lives
7/  Put lives and life count at bottom of screen - Done - will complete when 15 is done
8/  Add score and max score at top of screen - Done - HI score can only be done when 15 is done
9/  Make a start page
10/ Add ambulance at top of screen - Done
11/ Make animations for Saucer Bang and Gone - Done
12/ Put Ambulance in the collision grid - Done
13/ Blow up Ambulance - Done
14/ Add sounds - Done
15/ Check and tidy if needed the start up and reset order, e.g. open issue 5
16/ Set saucer speed relative to play canvas width
17/ Move turret by sliding as well as by touching - Done
18/ Add a life for more than a bonus score - Done
*/

/**
 * Created by AC on 3/25/2015.
 */

import android.content.res.Resources;
import android.graphics.Bitmap;
import android.graphics.BitmapFactory;
import android.graphics.Canvas;
import java.util.Random;

public class Sprite {
// Rank = 0..2 for Invader types 1..3,
// 4 for Saucer,
// 10..12 for bomb types 1 to 3,
//  20..25 for Fort 00, 01, 03, 11, 12, 21
    public int Rank;
    public int PosX;
    public int PosY;
    public Bitmap DisplayedIcon;
    // LastDisplayed is a reference for the last bitmap displayed for this item - it is
// used to flip the bitmaps for the different Invader Ranks so - if last was 1 display 2, etc.
    public int LastDisplayed;
    public boolean Hit; //Hit means that the Sprite has been hit by a missile
    public int Score; //Score is the score if that Sprite is hit
    public boolean Gone; // means that the Sprite is no longer visible after being hit
    public boolean Fired;
    public boolean Flying;

    public boolean getFlying() {
        return Flying;
    }

    public void setFlying(boolean flying) {
        Flying = flying;
    }


    public boolean isFired() {
        return Fired;
    }

    public boolean getFired() {
        return Fired;
    }

    public void setFired(boolean fired) {
        Fired = fired;
    }

    public boolean isGone() {

        return Gone;
    }

    public boolean getGone() {

        return Gone;
    }

    public void setGone(boolean gone) {
        Gone = gone;
    }

    public int getScore() {

        return Score;
    }

    public void setScore(int score) {
        Score = score;
    }

    public boolean isHit() {

        return Hit;
    }

    public void setHit(boolean hit) {
        Hit = hit;
    }

    public int getLastDisplayed() {

        return LastDisplayed;
    }

    public void setLastDisplayed(int lastDisplayed) {
        LastDisplayed = lastDisplayed;
    }

    public Bitmap getDisplayedIcon() {

        return DisplayedIcon;
    }

    public void setDisplayedIcon(Bitmap displayedIcon) {
        DisplayedIcon = displayedIcon;
    }

    public int getPosY() {

        return PosY;
    }

    public void setPosY(int posY) {
        PosY = posY;
    }

    public int getPosX() {

        return PosX;
    }

    public void setPosX(int posX) {
        PosX = posX;
    }

    public int getRank() {

        return Rank;
    }

    public void setRank(int rank) {
        Rank = rank;
    }
}



// The game created in this file is original work by Andrew Chisholm
// It is based on a canvas provided by the course "Begin Programming"
// provided by the University of Reading through FutureLearn; their
// original copyright notice is included below
// Copyright: Andrew Chisholm
// It is free software: you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.
//
// It is is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
//
// You should have received a copy of the GNU General Public License
// along with it.  If not, see <http://www.gnu.org/licenses/>.



