package uk.ac.reading.sis05kol.mooc;
/*
My favourite game on the CBM Pet was Space Invaders. On the Pet it was a good clone of the Atari
Arcade game. At the time, circa 1977, I thought that it would be a good exercise to program
the game "one day".

I joined the University of Reading Begin "Programming: Build Your First Mobile Game" course and
thought that the basic canvas supplied to provide a foundation for Space Invaders.

About 40 programming hours later this was the result.

It still needs startup splash, rollover from the base level to new levels, tidy finish to the game
and "High Score" stuff.

I based the game on a Youtube video of Atari live game play. It is intended visually and audibly
to be a close clone.

This set of files should compile under Android Studio. I run it on an emulator
Nexus 5X API 26 Android 8.0 X86, it runs in landscape mode. It has also been tested and runs
fine on real phones, a Samsung Galaxy 5, Sony Xperia Z, and Sony Xperia XZ

Andrew Chisholm

 */
// The Game - Invaders V0-7 - Date: 20150405
// The Game - Invaders V0-8 - Date: 20150405-2
// The Game - Invaders V0-9 - Date: 20150405-3 Bombs falling and number related to score
// The Game - Invaders V0-10 - Date: 20150406 Forts can be hit by the turret and by invaders, they
//                                            disintegrate gradually
// The Game - Invaders V0-11 - Date: 20150406-2 Targets are now 2D - this reduces the chance of a
//                                            miss and velocity of shells and bombs can be increased
// The Game - Invaders V0-12 - Date: 20150407 Fixed 4 - Added Saucer and made animations
// The Game - Invaders V0-13 - Date: 20150408 Added Saucer bangs
// The Game - Invaders V0-14 - Date: 20150415 Added sounds, exploding saucer, fixed some collision
//                                            grid bugs relating to the saucer and the sprites
// The Game - Invaders V0-15 - Date: 20150416 Added motion to the turret; it can now be operated
//                                            (right<>left) by sliding the finger
// The Game - Invaders V0-16 - Date: 20150419 Added Scores and score labels, number of lives,
//                                            number of life turrets, bonus life for 1000 points
// The Game - Invaders V0-17 - Date: 20150419-2 Busy with turret collisions and lives
// The Game - Invaders V0-18 - Date: 20150423 Added storage version sprites set mStorageVersion
//                                              true to play
// The Game - Invaders V1-01 - Date: 2151008
// Things to do:mStorageVersion
// 1/ Make it so that shells can hit bombs - both bomb and shell are neutralised
// 2/ Speed up
// 3/ Add startup screen
// 4/ When all aliens are gone call a new screen full of aliens with the aliens a step lower
//    and continue with the previous score
// 5/ When a game finishes go back to the startup screen.
//

/*
    Open Issues
3/ Sometimes a bang remains and is not cleared up - typically a top left corner. Looks like an
   array bounds issue
4/ Some bombs don't animate. An index had not been updated to [i] only the [0] was animating - Fixed
5/ Sometimes the turret doesn't seem to fire. It is firing but the shell doesn't get beyond the
   turret position - This seems to happen when the game restarts itself - this is not a valid
   condition

    Things to do
2/  Add Turret to collision grid
5/  Blow up turret
6/  Make lives
7/  Put lives and life count at bottom of screen - Done - will complete when 15 is done
8/  Add score and max score at top of screen - Done - HI score can only be done when 15 is done
9/  Make a start page
10/ Add ambulance at top of screen - Done
11/ Make animations for Saucer Bang and Gone - Done
12/ Put Ambulance in the collision grid - Done
13/ Blow up Ambulance - Done
14/ Add sounds - Done
15/ Check and tidy if needed the start up and reset order, e.g. open issue 5
16/ Set saucer speed relative to play canvas width
17/ Move turret by sliding as well as by touching - Done
18/ Add a life for more than a bonus score - Done
New updates - starting 20151019
19/ Remove timers for ambulance. Use effects based on movement
20/ Look for speed ups
New updates - starting 20181120
21/ Refactor to use getters and setters - in progress
22/ Sometimes forts are not hit and the shell passes through and hits the turret
23/ Explosions sometimes don't disappear
24/ at end of game need to cancel any current audio outputs
*/

//Other parts of the android libraries that we use
import android.graphics.Bitmap;
import android.graphics.BitmapFactory;
import android.graphics.Canvas;
import android.media.SoundPool;
import android.util.Log;
import java.util.Random;
import android.media.AudioManager;
//import android.media.SoundPool.Builder;
//import android.view.View.OnTouchListener;



public class TheGame extends GameThread{

    private boolean mStorageVersion = false;
    private boolean mSmallInvaders = true;
    private boolean mDebugMode = false;
    //Create Random object
    private Random mRando = new Random();

    //Create Sprite array for main Invader Fleet

    private Sprite [][] mSprites = new Sprite[11][5];

/*    public class Sprite {
// Rank = 0..2 for Invader types 1..3,
// 4 for Saucer,
// 10..12 for bomb types 1 to 3,
// 20..25 for Fort 00, 01, 03, 11, 12, 21
// 30 for Shell
    public int Rank;
    public int PosX;
    public int PosY;
    public Bitmap DisplayedIcon;
// LastDisplayed is a reference for the last bitmap displayed for this item - it is
// used to flip the bitmaps for the different Invader Ranks so - if last was 1 display 2, etc.
    public int LastDisplayed;
    public boolean Hit;
    public int Score;
    public boolean Gone;
    public boolean Fired;

}*/
//    int fred = (int) GameThread.getState();
// SFI - Speaks For Itself
    private Sprite mTurret = new Sprite();
    private Sprite mShell = new Sprite();
    private Sprite mSaucer = new Sprite();
    private Sprite [] mBombs = new Sprite[4];
    private int mNumberOfScoreDigits = 4;
    private Sprite [] mScore1Display = new Sprite[mNumberOfScoreDigits];
    private Sprite [] mScore2Display = new Sprite[mNumberOfScoreDigits];
    private Sprite [] mHiScoreDisplay = new Sprite[mNumberOfScoreDigits];
    private Bitmap [] mNumbers = new Bitmap[10];

    private int mNumberOfTextChars = 8;
    private Sprite [] mScore1Text = new Sprite[mNumberOfTextChars];
    private Sprite [] mScore2Text = new Sprite[mNumberOfTextChars];
    private Sprite [] mHiScoreText = new Sprite[mNumberOfTextChars];

//    private boolean mScoreTextDisplayed = false;
    private int mNumberOfLifeCountTurrets = 5;
    private Sprite [] mLifeCountTurrets = new Sprite[mNumberOfLifeCountTurrets];
    private Sprite mLifeCount = new Sprite();
    private int mNumberOfLives = 3;
    private int mNumberOfLivesLast = 0;

    private boolean mExtraLifeGiven = false;
    private int mBonusScore = 1000;


    private int mScore = 0; // Running score total value
    private int mPreviousScore = 0; // Previous running score total value

    private int mPlayer1Score = 0;
    private int mPlayer2Score = 0;
    private int mPlayer = 1;
    private int mNumberOfBombs = 4; // Number of bombs in the game
    private int mNumberOfBombsInUse = 1; // Number of bombs in use depends on first and last occupied columns
    private int mBombRank; // = 10..12 type of bomb - set up randomly each time a bomb is dropped
    private Sprite [][][] mFort = new Sprite[4][4][3];

    private SoundPool mSoundPool;
    private int msFirstNote; // reference to first repeating sound
    private int msSecondNote; // second
    private int msThirdNote; // third
    private int msFourthNote; // etc...
    private int mLastSound; // the sound that was played last 0..3
    private int mFirstNoteSilent;
    private int msFire; // reference to the firing sound
    private int msSaucerFlight;
    private int msSaucerFlightLong; // reference to the saucer sound
    private int msSaucerID; // Returned by the mSoundPool.play method as a stream id. Used to stop the saucer sound when the saucer is hit
    private int msFirstNoteID;
    private int msSecondNoteID;
    private int msThirdNoteID;
    private int msFourthNoteID;
    private int msSaucerBangID;
    private int msInvaderBangID;
    private int msFireID;
    private int msExplosionID;
    private int msSaucerBang; // reference to the saucer hit sound
    private int msInvaderBang; // reference to the invader hit sound
    private int msExplosion; // Turret blows up

    private float mTimerSaucer = 0f; // Times when saucer flies - compared with the random value
    private float mTimerSaucerRandom = ((mRando.nextFloat()*15) + 15); // Compared with the saucer timer to kick saucer into flight
    private float mTimerMoveLR; // Times when invaders are updated
    private float mTimerMoveInterval = 0.001f; //0.001f;  // Fixed time period compared with above
    private float mTimerSounds; // Times the pulsing four notes
    private float mTimerSoundsInterval = 1; // Used with above - initially one second later controlled by remaining occupied columns
    private int mLastRow; // Used with mLastCol to update position of invaders
    private int mLastCol; // Used with mLastRow to update position of invaders
    private int mFirstOccupiedCol = 0; // The left most column that still has invaders in it initially 0
    private int mLastOccupiedCol = 10; // The right most column that still has invaders in it initially 10
    private int mLastOccupiedRow = 4; //SFI

    private int mXInitialPos; // Sets the X spacing of the invaders - scaled to canvas size
    private int mYInitialPos; // Sets the Y spacing of the invaders - scaled to canvas size
    private int mXPosIncrement = 8; // Controls the speed of the invaders in X
    private int mXMaxIncrement = 60; // was 120 -  Max speed in X (when last invader standing)
    private int mYPosIncrement = 0; // Used to make the invaders descend one row - either 0 or mYPosStep
    private int mYPosStep = 24 * 3; // The increment in Y downwards
    private boolean mDownOne = false; // Set when the invaders reach right or left side - it says go down one next cycle
    private boolean mFire = false; // Set when a shell is in flight - reset when a hit is made or the screen top is reached
    private boolean mFortsDone = false; // Forts should only be put into the collision grid once at the start of the game
    private int mShellSpeed = 20; // Was 20 Speed of the shell - trade off between difficulty and missing the collision grid for an object
    private int mBombSpeed = 7; // Was 10 SFI - as above
    private int mSaucerSpeed = 5; // SFI
//    private int mTurretSpeed = 5;
//    private int mTurretXDestination = 5;
//    private boolean mSaucerFlying = false; // SFI
    private int [][] mCollisionGridX; // The collision grid is a grid behind the display area - one grid cell per 6 screen units
    private int [][] mCollisionGridY; // The collision grid is a grid behind the display area - one grid cell per 6 screen units
    private int mColGridMaxX; // Size of the grid in X - scaled to play canvas size
    private int mColGridMaxY; // Size of the grid in Y - scaled to play canvas size
    private int mSpriteWidth; // Used to hold the width of a sprite (would you believe!)
/*
* The PlayCanvas is a scaled square 15 x 15. From top to bottom the rows are:
* 0/ Labels |SCORE<1> in col 1..4|HI-SCORE col 6..9 SCORE<2> col 11..14
* 1/ SCORE<1>  HI-SCORE  SCORE<2> each in the form "0###"
* 2/ Flying saucer row
* 3/ Initial position of Invaders Rank 2
* 4-5/ Initial position of Invaders Rank 1
* 6-7/ Initial position of Invaders Rank 0
* 8-11/ Empty at beginning - space for the Invaders to move down
* 12/ Forts positioned at columns 2..3, 5..6, 8..9, 11..12
* 13/ Moving/active turret
* 14/ Spare turrets, baseline and credit score
*
* Column contents are:
* 14 RH End of screen
* 13 Empty
* 12..2 11 columns of sprites
* 1-0 Empty - left hand of screen
* The Bottom Row contains
* 0 # of lives/turrets left
* 1-5 is turret icons equal to lives left - 1
* 10..12 The word "CREDIT"
 * 13 the # credits in the form "0#"
* */
    private int mPlayCanvasWidth; // scaled section of the canvas effectively 15 squares by 15
    private int mPlayCanvasHeight; // scaled section of the canvas effectively 15 squares by 15
    private int mPlayXOffset; // space at the left (and right) of the screen before the play area starts
    private int mPlayYOffset; // space at the top (and bottom) of the screen before the play area starts
    private int mScaleX;
    private int mScaleY;

    // All these are SFI
    private Bitmap mInvaderBang;
    private Bitmap mInvaderBangGone;
    private Bitmap mInvaderBomb11; // Bomb type 1 bitmap 1
    private Bitmap mInvaderBomb12; // Bomb type 1 bitmap 2
    private Bitmap mInvaderBomb13; // Bomb type 1 bitmap 3
    private Bitmap mInvaderBomb14; // Bomb type 1 bitmap 4
    private Bitmap mInvaderBomb21; // Bomb type 2 bitmap 1
    private Bitmap mInvaderBomb22; // Bomb type 2 bitmap 2
    private Bitmap mInvaderBomb23; // etc...
    private Bitmap mInvaderBomb24;
    private Bitmap mInvaderBomb31;
    private Bitmap mInvaderBomb32;
    private Bitmap mInvaderBomb33;
    private Bitmap mInvaderBomb34;
    private Bitmap mInvaderBombGone;
    private Bitmap mInvaderRank11; // Invader type 1 bitmap 1
    private Bitmap mInvaderRank12; // Invader type 1 bitmap 2
    private Bitmap mInvaderRank21; // Invader type 2 bitmap 1
    private Bitmap mInvaderRank22; // Invader type 2 bitmap 2
    private Bitmap mInvaderRank31; // etc...
    private Bitmap mInvaderRank32;
    private Bitmap mInvaderSaucer;
    private Bitmap mInvaderSaucerBang;
    private Bitmap mInvaderSaucerGang;
    private Bitmap mInvaderSaucerSang;
    private Bitmap mInvaderSaucerBangGone;
    private Bitmap mInvaderSaucerScore050;
    private Bitmap mInvaderSaucerScore100;
    private Bitmap mInvaderSaucerScore150;
    private Bitmap mInvaderSaucerScore200;
    private Bitmap mInvaderFort00;
    private Bitmap mInvaderFort01;
    private Bitmap mInvaderFort03;
    private Bitmap mInvaderFort11;
    private Bitmap mInvaderFort12;
    private Bitmap mInvaderFort21;
    private Bitmap mInvaderFort22;
    private Bitmap mInvaderFortBang00;
    private Bitmap mInvaderFortBang01;
    private Bitmap mInvaderFortBang03;
    private Bitmap mInvaderFortBang11;
    private Bitmap mInvaderFortBang12;
    private Bitmap mInvaderFortBang21;
    private Bitmap mInvaderFortBangGone;
    private Bitmap mInvaderTurret;
    private Bitmap mInvaderTurretBang1;
    private Bitmap mInvaderTurretBang2;
    private Bitmap mInvaderTurretGone;

    private Bitmap mInvaderShell;

    private Bitmap mchar_number_0;
    private Bitmap mchar_number_1;
    private Bitmap mchar_number_2;
    private Bitmap mchar_number_3;
    private Bitmap mchar_number_4;
    private Bitmap mchar_number_5;
    private Bitmap mchar_number_6;
    private Bitmap mchar_number_7;
    private Bitmap mchar_number_8;
    private Bitmap mchar_number_9;
    private Bitmap mchar_number_blank;
    private Bitmap mchar_letter_h;
    private Bitmap mchar_letter_i;
    private Bitmap mchar_letter_s;
    private Bitmap mchar_letter_c;
    private Bitmap mchar_letter_o;
    private Bitmap mchar_letter_r;
    private Bitmap mchar_letter_e;
    private Bitmap mchar_symbol_gt;
    private Bitmap mchar_symbol_lt;
    private Bitmap mchar_symbol_minus;


    private SoundPool soundPool;

    //Turret's x position. Y will always be row 13 near the bottom of the screen
    private int mTurretX = -200;
    private int mTurretY = -200;

    private void UpdateLocalScore(int Player, int Score){

        int usThousands, usHundreds, usTens, usUnits;
        usThousands = Score / 1000;
        usHundreds = (Math.abs(Score - usThousands * 1000))/100;
        usTens = (Math.abs(Score - (usThousands * 1000 + usHundreds*100))) /10;
        usUnits = (Math.abs(Score - (usThousands * 1000 + usHundreds*100 + usTens * 10)));

        if ((Score > mBonusScore) && !mExtraLifeGiven) {
            mNumberOfLives++;
            mExtraLifeGiven = true;
        }
        if (Player == 1){
            mScore1Display[0].DisplayedIcon = mNumbers[usThousands];
            mScore1Display[1].DisplayedIcon = mNumbers[usHundreds];
            mScore1Display[2].DisplayedIcon = mNumbers[usTens];
            mScore1Display[3].DisplayedIcon = mNumbers[usUnits];
        }
        if (Player == 2){
            mScore2Display[0].DisplayedIcon = mNumbers[usThousands];
            mScore2Display[1].DisplayedIcon = mNumbers[usHundreds];
            mScore2Display[2].DisplayedIcon = mNumbers[usTens];
            mScore2Display[3].DisplayedIcon = mNumbers[usUnits];
        }
    }

    private void UpdateLifeCount(int LifeCount){

        int usThousands, usHundreds, usTens, usUnits;
        usThousands = LifeCount / 1000;
        usHundreds = (Math.abs(LifeCount - usThousands * 1000))/100;
        usTens = (Math.abs(LifeCount - (usThousands * 1000 + usHundreds*100))) /10;
        usUnits = (Math.abs(LifeCount - (usThousands * 1000 + usHundreds*100 + usTens * 10)));

        mLifeCount.DisplayedIcon = mNumbers[usUnits];
        // Life count stuff
        for (int i = 0; i < mNumberOfLifeCountTurrets; i++){
            mLifeCountTurrets[i].DisplayedIcon = mInvaderTurretGone;
        }
        for (int i = 0; i < mNumberOfLives - 1; i++){
            mLifeCountTurrets[i].DisplayedIcon = mInvaderTurret;
        }

    }

    private void endGame(){
        // Stop any running sounds
        mSoundPool.stop(msSaucerID);
        mSoundPool.stop(msFirstNoteID);
        mSoundPool.stop(msSecondNoteID);
        mSoundPool.stop(msThirdNoteID);
        mSoundPool.stop(msFourthNoteID);
        mSoundPool.stop(msSaucerBangID);
        mSoundPool.stop(msInvaderBangID);
        mSoundPool.stop(msFireID);
        mSoundPool.stop(msExplosionID);
        // set game state to lose
        setState(GameThread.STATE_LOSE);

    }

    //This is run before anything else, so we can prepare things here
    public TheGame(GameView gameView) {
        //House keeping
        super(gameView);
        //Log.w("AC","In TheGame"); // Used for debugging. Log variables using Log.w("AC","mTurretY = " + mTurretY);
        // Make the pool for sounds the first parameter is the number of sounds that can play simultaneously
        mSoundPool = new SoundPool(15, AudioManager.STREAM_MUSIC, 0);

// Load the sounds into soundpool and assign each to an int defined above
//    msFirstNote = mSoundPool.load(mContext, R.raw.first_note, 1);
        msFirstNote = mSoundPool.load(mContext, R.raw.first_note_filtered_oct, 1);
        msSecondNote = mSoundPool.load(mContext, R.raw.second_note_filtered_oct, 1);
        msThirdNote = mSoundPool.load(mContext, R.raw.third_note_filtered_oct, 1);
        msFourthNote = mSoundPool.load(mContext, R.raw.fourth_note_filtered_oct, 1);
        msFire = mSoundPool.load(mContext, R.raw.fire, 1);
        msSaucerFlight = mSoundPool.load(mContext, R.raw.saucer_flight, 1);
        msSaucerFlightLong = mSoundPool.load(mContext, R.raw.saucer_flight_long, 1);
        msSaucerBang = mSoundPool.load(mContext, R.raw.saucer_bang, 1);
        msInvaderBang = mSoundPool.load(mContext, R.raw.invader_bang, 1);
        msExplosion = mSoundPool.load(mContext, R.raw.explosion, 1);

/*  The Sprite based arrays are defined somewhere way above but with these pesky arrays in java it
    is not enough to have defined the arrays of type whatever you have to create a new object at
    each position in the array so - first for the main Invader array, then for the forts
*/
        for (int i=0; i < 11; i++) {
            for (int j = 0; j < 5; j++) {
                mSprites[i][j] = new Sprite();
            }
        }
        //Same for the forts k is the number of forts five in total 0..4
        for (int k=0; k<4; k++) {
            for (int i=0; i < 4; i++) {
                for (int j = 0; j < 3; j++) {
                    mFort[k][i][j] = new Sprite();
                }
            }
        }
        // Now for the bombs
        for (int i=0; i<mNumberOfBombs;i++){
            mBombs[i] = new Sprite();
        }

        //Prepare the images so we can draw them on the screen (using a canvas)
        if (mStorageVersion){
        } else {
            if (mSmallInvaders){
                mInvaderRank11 = BitmapFactory.decodeResource(gameView.getContext().getResources(), R.drawable.invader_rank200_11);
                mInvaderRank12 = BitmapFactory.decodeResource(gameView.getContext().getResources(), R.drawable.invader_rank200_12);
                mInvaderRank21 = BitmapFactory.decodeResource(gameView.getContext().getResources(), R.drawable.invader_rank200_21);
                mInvaderRank22 = BitmapFactory.decodeResource(gameView.getContext().getResources(), R.drawable.invader_rank200_22);
                mInvaderRank31 = BitmapFactory.decodeResource(gameView.getContext().getResources(), R.drawable.invader_rank200_31);
                mInvaderRank32 = BitmapFactory.decodeResource(gameView.getContext().getResources(), R.drawable.invader_rank200_32);
            } else {
                mInvaderRank11 = BitmapFactory.decodeResource(gameView.getContext().getResources(), R.drawable.invader_rank300_11);
                mInvaderRank12 = BitmapFactory.decodeResource(gameView.getContext().getResources(), R.drawable.invader_rank300_12);
                mInvaderRank21 = BitmapFactory.decodeResource(gameView.getContext().getResources(), R.drawable.invader_rank300_21);
                mInvaderRank22 = BitmapFactory.decodeResource(gameView.getContext().getResources(), R.drawable.invader_rank300_22);
                mInvaderRank31 = BitmapFactory.decodeResource(gameView.getContext().getResources(), R.drawable.invader_rank300_31);
                mInvaderRank32 = BitmapFactory.decodeResource(gameView.getContext().getResources(), R.drawable.invader_rank300_32);
            }
            mInvaderSaucer =  BitmapFactory.decodeResource(gameView.getContext().getResources(),R.drawable.invader_saucer300);
            mInvaderSaucerBang =  BitmapFactory.decodeResource(gameView.getContext().getResources(),R.drawable.invader_saucer_bang300b);
            mInvaderSaucerGang =  BitmapFactory.decodeResource(gameView.getContext().getResources(),R.drawable.invader_saucer_gang300b);
            mInvaderSaucerSang =  BitmapFactory.decodeResource(gameView.getContext().getResources(),R.drawable.invader_saucer_sang300b);
            mInvaderSaucerBangGone =  BitmapFactory.decodeResource(gameView.getContext().getResources(),R.drawable.invader_saucer_gone300);
            mInvaderTurret =  BitmapFactory.decodeResource(gameView.getContext().getResources(),R.drawable.invader_turret300);
            mInvaderTurretBang1 =  BitmapFactory.decodeResource(gameView.getContext().getResources(),R.drawable.invader_turret_bang1_300);
            mInvaderTurretBang2 =  BitmapFactory.decodeResource(gameView.getContext().getResources(),R.drawable.invader_turret_bang2_300);
            mInvaderTurretGone =  BitmapFactory.decodeResource(gameView.getContext().getResources(),R.drawable.invader_turret_gone300);
            mInvaderFort00 =  BitmapFactory.decodeResource(gameView.getContext().getResources(),R.drawable.invader_fort300_00);
            mInvaderFort01 =  BitmapFactory.decodeResource(gameView.getContext().getResources(),R.drawable.invader_fort300_01);
            mInvaderFort03 =  BitmapFactory.decodeResource(gameView.getContext().getResources(),R.drawable.invader_fort300_03);
            mInvaderFort11 =  BitmapFactory.decodeResource(gameView.getContext().getResources(),R.drawable.invader_fort300_11);
            mInvaderFort12 =  BitmapFactory.decodeResource(gameView.getContext().getResources(),R.drawable.invader_fort300_12);
            mInvaderFort21 =  BitmapFactory.decodeResource(gameView.getContext().getResources(),R.drawable.invader_fort300_21);
            mInvaderFort22 =  BitmapFactory.decodeResource(gameView.getContext().getResources(),R.drawable.invader_fort300_12);
            mInvaderFortBang00 =  BitmapFactory.decodeResource(gameView.getContext().getResources(),R.drawable.invader_fort_bang300_00);
            mInvaderFortBang01 =  BitmapFactory.decodeResource(gameView.getContext().getResources(),R.drawable.invader_fort_bang300_01);
            mInvaderFortBang03 =  BitmapFactory.decodeResource(gameView.getContext().getResources(),R.drawable.invader_fort_bang300_03);
            mInvaderFortBang11 =  BitmapFactory.decodeResource(gameView.getContext().getResources(),R.drawable.invader_fort_bang300_11);
            mInvaderFortBang12 =  BitmapFactory.decodeResource(gameView.getContext().getResources(),R.drawable.invader_fort_bang300_12);
            mInvaderFortBang21 =  BitmapFactory.decodeResource(gameView.getContext().getResources(),R.drawable.invader_fort_bang300_21);
            mInvaderFortBangGone =   BitmapFactory.decodeResource(gameView.getContext().getResources(),R.drawable.invader_fort_bang_gone300);
        }
        mInvaderBang =  BitmapFactory.decodeResource(gameView.getContext().getResources(),R.drawable.invader_bang300);
        mInvaderBangGone = BitmapFactory.decodeResource(gameView.getContext().getResources(),R.drawable.invader_bang_gone300);
        // Four bitmaps per bomb type for the animation
        mInvaderBomb11 =  BitmapFactory.decodeResource(gameView.getContext().getResources(),R.drawable.invader_bomb300_11);
        mInvaderBomb12 =  BitmapFactory.decodeResource(gameView.getContext().getResources(),R.drawable.invader_bomb300_12);
        mInvaderBomb13 =  BitmapFactory.decodeResource(gameView.getContext().getResources(),R.drawable.invader_bomb300_13);
        mInvaderBomb14 =  BitmapFactory.decodeResource(gameView.getContext().getResources(),R.drawable.invader_bomb300_14);
        mInvaderBomb21 =  BitmapFactory.decodeResource(gameView.getContext().getResources(),R.drawable.invader_bomb300_21);
        mInvaderBomb22 =  BitmapFactory.decodeResource(gameView.getContext().getResources(),R.drawable.invader_bomb300_22);
        mInvaderBomb23 =  BitmapFactory.decodeResource(gameView.getContext().getResources(),R.drawable.invader_bomb300_23);
        mInvaderBomb24 =  BitmapFactory.decodeResource(gameView.getContext().getResources(),R.drawable.invader_bomb300_24);
        mInvaderBomb31 =  BitmapFactory.decodeResource(gameView.getContext().getResources(),R.drawable.invader_bomb300_31);
        mInvaderBomb32 =  BitmapFactory.decodeResource(gameView.getContext().getResources(),R.drawable.invader_bomb300_32);
        mInvaderBomb33 =  BitmapFactory.decodeResource(gameView.getContext().getResources(),R.drawable.invader_bomb300_33);
        mInvaderBomb34 =  BitmapFactory.decodeResource(gameView.getContext().getResources(),R.drawable.invader_bomb300_34);
        mInvaderBombGone =  BitmapFactory.decodeResource(gameView.getContext().getResources(),R.drawable.invader_bomb_gone300);

        mInvaderSaucerScore050 = BitmapFactory.decodeResource(gameView.getContext().getResources(),R.drawable.invader_saucer_050_200);
        mInvaderSaucerScore100 = BitmapFactory.decodeResource(gameView.getContext().getResources(),R.drawable.invader_saucer_100_200);
        mInvaderSaucerScore150 = BitmapFactory.decodeResource(gameView.getContext().getResources(),R.drawable.invader_saucer_150_200);
        mInvaderSaucerScore200 = BitmapFactory.decodeResource(gameView.getContext().getResources(),R.drawable.invader_saucer_200_200);
        mInvaderShell =  BitmapFactory.decodeResource(gameView.getContext().getResources(),R.drawable.invader_shell300);
        mTurret.DisplayedIcon = mInvaderTurret; //BitmapFactory.decodeResource(gameView.getContext().getResources(),R.drawable.invader_turret300);

        mchar_number_0 =  BitmapFactory.decodeResource(gameView.getContext().getResources(),R.drawable.char_number_0);
        mchar_number_1 =  BitmapFactory.decodeResource(gameView.getContext().getResources(),R.drawable.char_number_1);
        mchar_number_2 =  BitmapFactory.decodeResource(gameView.getContext().getResources(),R.drawable.char_number_2);
        mchar_number_3 =  BitmapFactory.decodeResource(gameView.getContext().getResources(),R.drawable.char_number_3);
        mchar_number_4 =  BitmapFactory.decodeResource(gameView.getContext().getResources(),R.drawable.char_number_4);
        mchar_number_5 =  BitmapFactory.decodeResource(gameView.getContext().getResources(),R.drawable.char_number_5);
        mchar_number_6 =  BitmapFactory.decodeResource(gameView.getContext().getResources(),R.drawable.char_number_6);
        mchar_number_7 =  BitmapFactory.decodeResource(gameView.getContext().getResources(),R.drawable.char_number_7);
        mchar_number_8 =  BitmapFactory.decodeResource(gameView.getContext().getResources(),R.drawable.char_number_8);
        mchar_number_9 =  BitmapFactory.decodeResource(gameView.getContext().getResources(),R.drawable.char_number_9);
        mchar_number_blank =  BitmapFactory.decodeResource(gameView.getContext().getResources(),R.drawable.char_number_blank);

        mchar_letter_h =  BitmapFactory.decodeResource(gameView.getContext().getResources(),R.drawable.char_letter_h);
        mchar_letter_i =  BitmapFactory.decodeResource(gameView.getContext().getResources(),R.drawable.char_letter_i);
        mchar_letter_s =  BitmapFactory.decodeResource(gameView.getContext().getResources(),R.drawable.char_letter_s);
        mchar_letter_c =  BitmapFactory.decodeResource(gameView.getContext().getResources(),R.drawable.char_letter_c);
        mchar_letter_o =  BitmapFactory.decodeResource(gameView.getContext().getResources(),R.drawable.char_letter_o);
        mchar_letter_r =  BitmapFactory.decodeResource(gameView.getContext().getResources(),R.drawable.char_letter_r);
        mchar_letter_e =  BitmapFactory.decodeResource(gameView.getContext().getResources(),R.drawable.char_letter_e);
        mchar_symbol_gt =  BitmapFactory.decodeResource(gameView.getContext().getResources(),R.drawable.char_symbol_gt);
        mchar_symbol_lt =  BitmapFactory.decodeResource(gameView.getContext().getResources(),R.drawable.char_symbol_lt);
        mchar_symbol_minus =  BitmapFactory.decodeResource(gameView.getContext().getResources(),R.drawable.char_symbol_minus);

        // Now for the score arrays and load "0000"
        for (int i = 0; i < mNumberOfScoreDigits; i++){
            mScore1Display[i] = new Sprite();
            mScore1Display[i].setDisplayedIcon(mchar_number_0);
            mScore2Display[i] = new Sprite();
            mScore2Display[i].setDisplayedIcon(mchar_number_0);
            mHiScoreDisplay[i] = new Sprite();
            mHiScoreDisplay[i].setDisplayedIcon(mchar_number_0);
        }
        // Now for the score label text arrays
        for (int i = 0; i < mNumberOfTextChars; i++){
            mScore1Text[i] = new Sprite();
            mScore2Text[i] = new Sprite();
            mHiScoreText[i] = new Sprite();
        }
        mScore1Text[0].DisplayedIcon = (mchar_letter_s); mScore1Text[1].setDisplayedIcon(mchar_letter_c);
        mScore1Text[2].setDisplayedIcon(mchar_letter_o); mScore1Text[3].setDisplayedIcon(mchar_letter_r);
        mScore1Text[4].setDisplayedIcon(mchar_letter_e); mScore1Text[5].setDisplayedIcon(mchar_symbol_lt);
        mScore1Text[6].setDisplayedIcon(mchar_number_1); mScore1Text[7].setDisplayedIcon(mchar_symbol_gt);

        mScore2Text[0].setDisplayedIcon(mchar_letter_s);
        mScore2Text[1].setDisplayedIcon(mchar_letter_c);
        mScore2Text[2].setDisplayedIcon(mchar_letter_o);
        mScore2Text[3].setDisplayedIcon(mchar_letter_r);
        mScore2Text[4].setDisplayedIcon(mchar_letter_e);
        mScore2Text[5].setDisplayedIcon(mchar_symbol_lt);
        mScore2Text[6].setDisplayedIcon(mchar_number_2);
        mScore2Text[7].setDisplayedIcon(mchar_symbol_gt);

        mHiScoreText[0].setDisplayedIcon(mchar_letter_h);
        mHiScoreText[1].setDisplayedIcon(mchar_letter_i);
        mHiScoreText[2].setDisplayedIcon(mchar_symbol_minus);
        mHiScoreText[3].setDisplayedIcon(mchar_letter_s);
        mHiScoreText[4].setDisplayedIcon(mchar_letter_c);
        mHiScoreText[5].setDisplayedIcon(mchar_letter_o);
        mHiScoreText[6].setDisplayedIcon(mchar_letter_r);
        mHiScoreText[7].setDisplayedIcon(mchar_letter_e);

        mNumbers[0] = mchar_number_0;
        mNumbers[1] = mchar_number_1;
        mNumbers[2] = mchar_number_2;
        mNumbers[3] = mchar_number_3;
        mNumbers[4] = mchar_number_4;
        mNumbers[5] = mchar_number_5;
        mNumbers[6] = mchar_number_6;
        mNumbers[7] = mchar_number_7;
        mNumbers[8] = mchar_number_8;
        mNumbers[9] = mchar_number_9;

        for (int i=0; i<mNumberOfLifeCountTurrets; i++){
            mLifeCountTurrets[i] = new Sprite();
            mLifeCountTurrets[i].setDisplayedIcon(mInvaderTurretGone); //DisplayedIcon = mInvaderTurretGone;
        }

/* There are four forts - k=0; k<4
   Each fort is created from twelve pieces (each a separate Sprite) in four columns (i) and three rows (j)
   The idea is that each one acts as a separate collision target and can be blown up piece by piece.
   The forts are set up with bitmaps, etc. here. The positions are done later because at this
   moment the canvas is not available to measure its size.
*/
        for (int k=0; k<4; k++) {
            for (int i=0; i < 4; i++) {
                for (int j = 0; j < 3; j++) {
                    mFort[k][i][j].setRank(0);
                    mFort[k][i][j].setPosX(-200);
                    mFort[k][i][j].setPosY(-200);
                    if(i == 0) {
                        if (j == 0) {
                            mFort[k][i][j].setDisplayedIcon(mInvaderFort00);
                            mFort[k][i][j].setRank(20);
                        }
                        else {
                            mFort[k][i][j].setDisplayedIcon(mInvaderFort01);
                            mFort[k][i][j].setRank(21);
                        }
                    }
                    else if (i == 1){
                        if (j == 0){
                            mFort[k][i][j].setDisplayedIcon(mInvaderFort01);
                            mFort[k][i][j].setRank(21);
                        }
                        else if (j == 1) {
                            mFort[k][i][j].setDisplayedIcon(mInvaderFort11);
                            mFort[k][i][j].setRank(23);
                        }
                        else if (j == 2){ // Yes, I know that I could use "else" here and that if
                            // we get here this is always true. But, If I need to extend it to
                            // J could == 3 then I am already half way there. That's why!
                            mFort[k][i][j].setDisplayedIcon(mInvaderFort12);
                            mFort[k][i][j].setRank(24);
                        }
                    }
                    else if (i == 2){
                            if (j == 0){
                                mFort[k][i][j].setDisplayedIcon(mInvaderFort01);
                                mFort[k][i][j].setRank(21);
                            }
                            else if (j == 1) {
                                mFort[k][i][j].setDisplayedIcon(mInvaderFort21);
                                mFort[k][i][j].setRank(25);
                            }
                            else if (j == 2){
                                mFort[k][i][j].setDisplayedIcon(mInvaderFort22);
                                mFort[k][i][j].setRank(24);
                            }
                    }
                    else if (i == 3) {
                        if (j == 0) {
                            mFort[k][i][j].setDisplayedIcon(mInvaderFort03);
                            mFort[k][i][j].setRank(22);
                        }
                        else {
                            mFort[k][i][j].setDisplayedIcon(mInvaderFort01);
                            mFort[k][i][j].setRank(21);
                        }
                    }
                    mFort[k][i][j].setLastDisplayed(1);
                }
            }
        }

// Set up the shell Sprite but park it out of sight just now
        mShell.setRank(30);
        mShell.setPosX(-200);
        mShell.setPosY(-200);
        mShell.setDisplayedIcon(mInvaderShell);
        mShell.setLastDisplayed(1);

// Set up the Saucer Sprite but park it out of sight just now
        mSaucer.setRank(30); // Should this be '4', 30 is the rank for a shell
        mSaucer.setDisplayedIcon(mInvaderSaucer);
        mSaucer.setLastDisplayed(1);
        mSaucer.setPosX(-mSaucer.DisplayedIcon.getWidth());
        mSaucer.setPosY(-200);
        mSaucer.setScore(100);
//        mSaucerFlying = false;
        mSaucer.setFlying(false);
        mSaucer.setHit(false);
        mSaucer.setGone(false);

// Set up first saucer flight wait period

        for (int i = 0; i < mNumberOfBombs;i++) {
            mBombs[i].setPosX(-200);
            mBombs[i].setPosY(-200);
            mBombs[i].setDisplayedIcon(mInvaderBomb11);
            mBombs[i].setLastDisplayed(1);

        }
        for (int i = 0; i < 11; i++ ) {
            mSprites[i][0].setRank(2);
            mSprites[i][1].setRank(1);
            mSprites[i][2].setRank(1);
            mSprites[i][3].setRank(0);
            mSprites[i][4].setRank(0);
        }

        mXInitialPos = mCanvasWidth/13;
        mYInitialPos = mCanvasHeight/30;


        for (int i = 0; i < 11 ; i++ ) {
            for (int j = 0; j < 5; j++) {
                mSprites[i][j].setPosX(-200);
                mSprites[i][j].setPosY(-200);
                mSprites[i][j].setLastDisplayed(1);
                if (mSprites[i][j].getRank() == 0) {
                    mSprites[i][j].setDisplayedIcon(mInvaderRank11);
                    mSprites[i][j].setScore(10);
                }
                else if (mSprites[i][j].getRank() == 1) {
                    mSprites[i][j].setDisplayedIcon(mInvaderRank21);
                    mSprites[i][j].setScore(20);
                }
                else if (mSprites[i][j].getRank() == 2) {
                    mSprites[i][j].setDisplayedIcon(mInvaderRank31);
                    mSprites[i][j].setScore(30);
                }
            }
        }
    }

    //This is run before a new game (also after an old game)
    @Override
    public void setupBeginning() {
        //Log.w("AC","In setupBeginning");
        //Initialise speeds
        //mCanvasWidth and mCanvasHeight are declared and managed elsewhere
        // Set up play area
        mPlayCanvasWidth = mCanvasWidth/90;
        mPlayCanvasWidth = 90 * mPlayCanvasWidth;
        mPlayCanvasHeight = mCanvasHeight/90;
        mPlayCanvasHeight = 90 * mPlayCanvasHeight;
        mPlayXOffset = (mCanvasWidth - mPlayCanvasWidth)/2;
        mPlayYOffset = (mCanvasHeight - mPlayCanvasHeight)/2;
        //Place Turret in the middle of the screen
        mTurret.setPosX(mPlayXOffset + (mPlayCanvasWidth / 2));
        mTurret.setPosY((13 * mPlayCanvasHeight) /15);
        mLastRow = 0;
        mLastCol = 10;
        mXPosIncrement = 6;

        mXInitialPos = mPlayCanvasWidth/15;
        mYInitialPos = mPlayCanvasHeight/15;

/*  Set up the collision grid. The collision grid is a pair of 2 dimensional arrays that cover
    the Play Canvas Width. There is one grid per six display pixels, and they are initialised to -1
    Each item that can be "hit" writes to the collision grid over the area that it occupies, as it
    moves it zeroes its old location and writes again to the new location. Invaders write their X and Y
*/
        mColGridMaxX = 100 + mPlayCanvasWidth/6;
        mColGridMaxY = 100 + mPlayCanvasHeight/6;
        mCollisionGridX = new int[mColGridMaxX][mColGridMaxY];
        mCollisionGridY = new int[mColGridMaxX][mColGridMaxY];
        for (int i = 0; i < mColGridMaxX; i++) {
            for (int j = 0; j < mColGridMaxY; j++) {
                mCollisionGridX[i][j] = -1;
                mCollisionGridY[i][j] = -1;
            }
        }

// This needs to change
        for (int i = 0; i < 11 ; i++ ) {
            for (int j = 0; j < 5; j++) {
                mSprites[i][j].setPosX(mPlayXOffset + ((i + 2) * mXInitialPos));
                mSprites[i][j].setPosY(mPlayYOffset + ((j + 3) * mYInitialPos));
            }
        }

// Set up the collision grid for the Forts. This should only be run if the game is restarted
        if (!mFortsDone){

            for (int k=0 ; k<4 ; k++){
                for (int i=0; i<4; i++){
                    for (int j=0; j<3 ; j++){
//                        int temp;
                        //mFort[k][i][j].Rank = 0;
                        mFort[k][i][j].setPosX(mPlayXOffset + (mPlayCanvasWidth/5) *(k+1) - (mInvaderFort00.getWidth() * 2) + (mInvaderFort00.getWidth() * i));
                        mFort[k][i][j].setPosY(mPlayYOffset + mPlayCanvasHeight - (mInvaderFort00.getHeight() * 3 * 2) + (mInvaderFort00.getHeight() * j));
                        for (int x = 0; x < mInvaderFort00.getWidth()/6;x++) {
                            for (int y = 0; y < mInvaderFort00.getHeight() / 6; y++) {
                                mCollisionGridX[x + mFort[k][i][j].getPosX() / 6][y + mFort[k][i][j].getPosY() / 6] = (k + 1) * 100 + i;
                                mCollisionGridY[x + mFort[k][i][j].getPosX() / 6][y + mFort[k][i][j].getPosY() / 6] = (k + 1) * 100 + j;
                            }
                        }
                    }
                }
            }
            mFortsDone = true;
        }

        mSaucer.setPosY(mPlayYOffset + (2 * mPlayCanvasHeight/15));
        // Set position for scores
        for (int i = 0; i < mNumberOfScoreDigits; i++){
            mScore1Display[i].setPosY(mPlayYOffset + (1 * mPlayCanvasHeight/15));
            mScore1Display[i].setPosX(mPlayXOffset + 1 * mPlayCanvasWidth/7 + i * (mScore1Display[i].getDisplayedIcon().getWidth() + 6));
            mScore2Display[i].setPosY(mPlayYOffset + (1 * mPlayCanvasHeight/15));
            mScore2Display[i].setPosX(mPlayXOffset + 5 * mPlayCanvasWidth/7 + i * (mScore2Display[i].getDisplayedIcon().getWidth() + 6));
            mHiScoreDisplay[i].setPosY(mPlayYOffset + (1 * mPlayCanvasHeight/15));
            mHiScoreDisplay[i].setPosX(mPlayXOffset + 3 * mPlayCanvasWidth/7 + i * (mHiScoreDisplay[i].getDisplayedIcon().getWidth() + 6));
        }

        for (int i = 0; i < mNumberOfTextChars; i++){
            mScore1Text[i].setPosY(mPlayYOffset + (0 * mPlayCanvasHeight/15));
            mScore1Text[i].setPosX(mPlayXOffset + 1 * mPlayCanvasWidth/7 - (2 * mScore1Text[0].getDisplayedIcon().getWidth()) + i * (mScore1Text[i].getDisplayedIcon().getWidth()+6));
            mScore2Text[i].setPosY(mPlayYOffset + (0 * mPlayCanvasHeight/15));
            mScore2Text[i].setPosX(mPlayXOffset + 5 * mPlayCanvasWidth/7 - (2 * mScore2Text[0].getDisplayedIcon().getWidth()) + i *  (mScore2Text[i].getDisplayedIcon().getWidth()+6));
            mHiScoreText[i].setPosY(mPlayYOffset + (0 * mPlayCanvasHeight/15));
            mHiScoreText[i].setPosX(mPlayXOffset + 3 * mPlayCanvasWidth/7 - (2 * mHiScoreText[0].getDisplayedIcon().getWidth()) + i *  (mHiScoreText[i].getDisplayedIcon().getWidth()+6));
        }
        mLifeCount.setPosX(mPlayXOffset + (1 * mPlayCanvasWidth/10));
        mLifeCount.setPosY(mPlayYOffset + 6 + (14 * mPlayCanvasHeight/15));

        for (int i = 0; i < mNumberOfLifeCountTurrets; i++){
            mLifeCountTurrets[i].setPosX(mPlayXOffset + ((i + 2) * mPlayCanvasWidth/10)); // Leave space for the life count
            mLifeCountTurrets[i].setPosY(mPlayYOffset + (14 * mPlayCanvasHeight/15));
        }
    }

    @Override
    protected void doDraw(Canvas canvas) {
        //Log.w("AC","In doDraw");
        //If there isn't a canvas to do nothing
        //It is ok not understanding what is happening here
        if(canvas == null) return;
        //House keeping
        super.doDraw(canvas);

        //canvas.drawBitmap(bitmap, x, y, paint) uses top/left corner of bitmap as 0,0
        //we use 0,0 in the middle of the bitmap, so negate half of the width and height of the ball to draw the ball as expected
        //A paint of null means that we will use the image without any extra features (called Paint)

        // Draw the forts
        for (int k=0; k<4; k++) {
            for (int i=0; i < 4; i++) {
                for (int j=0; j < 3; j++) {
                    if (!mFort[k][i][j].isGone()){
                        canvas.drawBitmap(mFort[k][i][j].getDisplayedIcon(), mFort[k][i][j].getPosX(), mFort[k][i][j].getPosY(), null);

                    }
                }
            }
        }
        // Draw the invaders array
        for (int i=0; i < 11; i++){
            for (int j = 4; j >=0; j--) {
                if (!mSprites[i][j].isGone()) {
                    canvas.drawBitmap(mSprites[i][j].getDisplayedIcon(), mSprites[i][j].getPosX(), mSprites[i][j].getPosY(), null);
                }
            }
        }

        //Draw player's Turret
        canvas.drawBitmap(mTurret.getDisplayedIcon(), mTurret.getPosX(), mTurret.getPosY(), null);

        //Draw Shell
        if (mFire) canvas.drawBitmap(mShell.getDisplayedIcon(), mShell.getPosX(), mShell.getPosY(), null);

        //Draw Saucer
        if (mSaucer.getFlying() || mSaucer.isHit()){canvas.drawBitmap(mSaucer.getDisplayedIcon(), mSaucer.getPosX(), mSaucer.getPosY(), null);}

        //Draw Scores
        if (mScore1Display[0].getPosX() != 0){
            for (int i = 0; i < mNumberOfScoreDigits; i++) {
                canvas.drawBitmap(mScore1Display[i].getDisplayedIcon(), mScore1Display[i].getPosX(), mScore1Display[i].getPosY(), null);
                canvas.drawBitmap(mScore2Display[i].getDisplayedIcon(), mScore2Display[i].getPosX(), mScore2Display[i].getPosY(), null);
                canvas.drawBitmap(mHiScoreDisplay[i].getDisplayedIcon(), mHiScoreDisplay[i].getPosX(), mHiScoreDisplay[i].getPosY(), null);
            }
        }

      //  if (mScore1Text[0].PosX != 0 && !mScoreTextDisplayed){
            for (int i = 0; i < mNumberOfTextChars; i++) {
                canvas.drawBitmap(mScore1Text[i].getDisplayedIcon(), mScore1Text[i].getPosX(), mScore1Text[i].getPosY(), null);
                canvas.drawBitmap(mScore2Text[i].getDisplayedIcon(), mScore2Text[i].getPosX(), mScore2Text[i].getPosY(), null);
                canvas.drawBitmap(mHiScoreText[i].getDisplayedIcon(), mHiScoreText[i].getPosX(), mHiScoreText[i].getPosY(), null);
            }
         //   mScoreTextDisplayed = false;
       // }
            if (mNumberOfLives != mNumberOfLivesLast){
                UpdateLifeCount(mNumberOfLives);
                mNumberOfLivesLast = mNumberOfLives;
            }
            canvas.drawBitmap(mLifeCount.DisplayedIcon, mLifeCount.getPosX(), mLifeCount.getPosY(), null);
            for (int i=0; i< mNumberOfLifeCountTurrets;i++){
                canvas.drawBitmap(mLifeCountTurrets[i].getDisplayedIcon(), mLifeCountTurrets[i].getPosX(), mLifeCountTurrets[i].getPosY(), null);
            }
       // }

        //Draw Bombs
        for (int i=0; i<mNumberOfBombs;i++){
            if (mBombs[i].getFired()) canvas.drawBitmap(mBombs[i].getDisplayedIcon(), mBombs[i].getPosX(), mBombs[i].getPosY(), null);
        }

        // Get last occupied row and if it touches the tops of the fort level stop the game
        int mCount = 0;
        //mLastOccupiedRow = 4;
        while (mSprites[mCount][mLastOccupiedRow].Hit ) {
            mCount++;
            if (mCount > 10) {
                mLastOccupiedRow--;
                if (mLastOccupiedRow < 0){
                    mLastOccupiedRow = 0;
                    setState(GameThread.STATE_WIN);

                }
                mCount = 0;
            }
        }
        //Log.w("AC","mLastOccupiedRow = " + mLastOccupiedRow);
        if ((mSprites[mFirstOccupiedCol][mLastOccupiedRow].getPosY() + mInvaderRank11.getHeight()) >= mFort[0][0][0].getPosY()){
            //setState(GameThread.STATE_LOSE);
            endGame();
        }
    }

    //This is run whenever the phone is touched by the user-
    @Override
    protected void actionOnTouch(float x, float y, boolean b) {
        //Log.w("AC","In actionOnTouch");
        //Scale x and y
        mScaleX = (int) x - mPlayXOffset; //mPlayXOffset + (int)(x * (float)mPlayCanvasWidth/mCanvasWidth);
        if (mScaleX < 0) mScaleX = 0;
        mScaleY = (int) y - mPlayYOffset; //mPlayYOffset + (int)(y * (float)mPlayCanvasHeight/mCanvasHeight);
        if (mScaleY < 0) mScaleY = 0;
        //Move the turret to the x position of the touch
        //mTurretSpeed = 1 * (mScaleX - (mTurretX + mTurret.DisplayedIcon.getWidth()/2))/500;
        //Log.w("AC","mTurretSpeed = " + mTurretSpeed);

        if (b && (mScaleX > mTurret.getPosX()) && (mScaleX < (mTurret.getPosX() + mTurret.getDisplayedIcon().getWidth()))) {
            if (!mFire && !mTurret.isHit()){    // This prevents firing a second time until mFire is false
                // by means of a hit or top of screen
                mFire = true;
//                for (int i = 0; i<mTurret.DisplayedIcon.getWidth()/6; i++){
//                    for (int j = 0; j<mTurret.DisplayedIcon.getHeight()/6; j++){
//                        mCollisionGridX[i + mTurret.PosX/6][j + mTurret.PosY/6] = -1;
//                        mCollisionGridY[i + mTurret.PosX/6][j + mTurret.PosY/6] = -1;
//                    }
//                }
                mShell.setPosX((mTurret.getPosX() + mTurret.getDisplayedIcon().getWidth()/2));
                mShell.setPosY((mTurret.getPosY() - mShell.getDisplayedIcon().getHeight()));
                msFireID = mSoundPool.play(msFire, 1.0f, 1.0f, 1, 0, 1.0f);
//                for (int i = 0; i<mTurret.DisplayedIcon.getWidth()/6; i++){
//                    for (int j = 0; j<mTurret.DisplayedIcon.getHeight()/6; j++){
//                        mCollisionGridX[i + mTurret.PosX/6][j + mTurret.PosY/6] = 1100;
//                        mCollisionGridY[i + mTurret.PosX/6][j + mTurret.PosY/6] = 1100;
//                    }
//                }
            }
        }
        for (int i = 0; i<mTurret.getDisplayedIcon().getWidth()/6; i++){
            for (int j = 0; j<mTurret.getDisplayedIcon().getHeight()/6; j++){
                mCollisionGridX[i + mTurret.getPosY()/6][j + mTurret.getPosY()/6] = -1;
                mCollisionGridY[i + (mTurret.getPosX() / 6)][j + mTurret.getPosY()/6] = -1;
            }
        }
        if (!mTurret.isHit()){
            mTurret.setPosX(mPlayXOffset + mScaleX - mTurret.DisplayedIcon.getWidth() / 2);
            if (mTurret.getPosX() < 0){mTurret.setPosX(0);}
            if (mTurret.getPosX() > (mPlayCanvasWidth - mTurret.getDisplayedIcon().getWidth())){
                mTurret.setPosX(mPlayCanvasWidth - mTurret.getDisplayedIcon().getWidth());
            }
            for (int i = 0; i<mTurret.getDisplayedIcon().getWidth()/6; i++){
                for (int j = 0; j<mTurret.getDisplayedIcon().getHeight()/6; j++){
                    mCollisionGridX[i + mTurret.getPosX()/6][j + mTurret.getPosY()/6] = 1100;
                    mCollisionGridY[i + mTurret.getPosX()/6][j + mTurret.getPosY()/6] = 1100;
                }
            }
        }
    }

    //This is run whenever the phone moves around its axises
    @Override
    protected void actionWhenPhoneMoved(float xDirection, float yDirection, float zDirection) {
        //Log.w("AC","In actionWhenPhoneMoved");
/*
        //Change the paddle speed
        mTurretSpeedX = mTurretSpeedX + 70f * xDirection;

        //If paddle is outside the screen and moving further away
        //Move it into the screen and set its speed to 0
        if(mTurretX <= 0 && mTurretSpeedX < 0) {
            mTurretSpeedX = 0;
            mTurretX = 0;
        }
        if(mTurretX >= mCanvasWidth && mTurretSpeedX > 0) {
            mTurretSpeedX = 0;
            mTurretX = mCanvasWidth;
        }
*/
    }

    //This is run just before the game "scenario" is printed on the screen
    @Override
    protected void updateGame(float secondsElapsed) {
        //Log.w("AC","In updateGame");
        // Movement right and left is controlled by the mXPosIncrement; if positive it is moving
        // right, if negative it is moving left
        //
        // Speed of movement is based on the number of columns still occupied in the middle block.
        // The code below calculates a mXPosIncrement between mXMaxIncrement/(number of columns
        // between right and left) and mXMaxIncrement
        // The code below calculates mXPosIncrement and switches it -ve and +ve to change direction
        // when the last occupied column reaches right or left.
        mSpriteWidth = mSprites[mLastOccupiedCol][1].getDisplayedIcon().getWidth();
        mXPosIncrement = Integer.signum(mXPosIncrement) * (mXMaxIncrement / ((mSpriteWidth / 6) * Math.round((1 + mLastOccupiedCol - mFirstOccupiedCol)) / (mSpriteWidth / 6)));
        // Detect right or left and reverse direction also set up for moving down
        if ((mXPosIncrement > 0) && ((mSprites[mLastOccupiedCol][0].getPosX() + mSpriteWidth) >= (mPlayXOffset + mPlayCanvasWidth))) {
            mXPosIncrement = -1 * mXPosIncrement;
            mDownOne = true;
        } else {
            if ((mXPosIncrement < 0) && ((mSprites[mFirstOccupiedCol][4].getPosX()) <= mPlayXOffset)) {
                mSprites[mFirstOccupiedCol][4].setPosX(mSprites[mFirstOccupiedCol][4].getPosX() - (2 * mXPosIncrement));
                mXPosIncrement = -1 * mXPosIncrement;
                mDownOne = true;
            }
        }
        /* If actively firing a shell examine the collision grid at the shell location to
        see if we have hit anything
        There is one set of two collision grids one grid stores the X coordinate the other stores
        the Y coordinate. The meaning of the coordinates varies depending on the object type.

        The location of Invader Sprites is stored as the row and column of the Invader's location
        in the mSprite array; X 0..10, and Y 0..4. Invaders are X and Y values >= 0 AND <100

        Forts are made up of 12 separate sprites so that they can be blown up a bit at a time.
        Forts are stored in the collision grid using numbers between 100 and 999 in the form [k+1][x][y] where k is the fort
        number (0..3), x is the x coordinate of the fort sprite, and y is the y coordinate of
        the fort sprite 0..3, e.g. 100 = [0][0][0], 302 is [2][0][2]
         [0][0,0][0,1][0,2][0.3]    [1][0,0][0,1][0,2][0.3]    [2][0,0][0,1][0,2][0.3]    etc...
            [1,0][1,1][1,2][1,3]       [1,0][1,1][1,2][1,3]       [1,0][1,1][1,2][1,3]
            [2,0][2,1][2,2][2,3]       [2,0][2,1][2,2][2,3]       [2,0][2,1][2,2][2,3]

        */
        // Has a shell been fired that is not yet at top of screen
        if (mFire && mShell.getPosY() >= 0) {
            int mColGridX = mCollisionGridX[mShell.getPosX() / 6][mShell.getPosY() / 6];
            int mColGridY = mCollisionGridY[mShell.getPosX() / 6][mShell.getPosY() / 6];
            // Have we hit an Invader?
            if ((mColGridX != -1) && (mColGridY != -1)) {
                if ((mColGridX >= 0 && mColGridX < 100) && (mColGridY >= 0 && mColGridY < 100)) {
                    mSprites[mColGridX][mColGridY].setDisplayedIcon(mInvaderBang);
                    mSprites[mColGridX][mColGridY].setLastDisplayed(3);
                    mSprites[mColGridX][mColGridY].setHit(true);
                    //updateScore(mSprites[mColGridX][mColGridY].getScore());
                    mScore += mSprites[mColGridX][mColGridY].getScore();
                    //UpdateLocalScore(mPlayer, mScore);
                    msInvaderBangID = mSoundPool.play(msInvaderBang, 1.0f, 1.0f, 1, 0, 1.0f);
                    // Remove the sprite from the collision grid
                    int mThisSpriteWidth = mSprites[mColGridX][mColGridY].getDisplayedIcon().getWidth() / 6;
                    int mThisSpriteHeight = mSprites[mColGridX][mColGridY].getDisplayedIcon().getHeight() / 6;
                    int mThisSpritePosX = mSprites[mColGridX][mColGridY].getPosX();
                    int mThisSpritePosY = mSprites[mColGridX][mColGridY].getPosY();
                    for (int i = 0; i < mThisSpriteWidth; i++) {
                        for (int j = 0; j < mThisSpriteHeight; j++) {
                            mCollisionGridX[i + mThisSpritePosX / 6][j + mThisSpritePosY / 6] = -1;
                            mCollisionGridY[i + mThisSpritePosX / 6][j + mThisSpritePosY / 6] = -1;
                        }
                    }
                    mFire = false;
                // Have we hit a Fort? - Shouldn't have done that!
                } else if ((mColGridX >= 100 && mColGridX < 1000) && (mColGridY >= 100 && mColGridY < 1000)) {
                    int k = ((mColGridX) / 100);
                    if (mFort[k - 1][mColGridX - (k * 100)][mColGridY - (k * 100)].getLastDisplayed() == 1) {
                        switch (mFort[k - 1][mColGridX - (k * 100)][mColGridY - (k * 100)].getRank()){
                            case 20:
                                mFort[k - 1][mColGridX - (k * 100)][mColGridY - (k * 100)].setDisplayedIcon(mInvaderFortBang00);
                                break;
                            case 21:
                                mFort[k - 1][mColGridX - (k * 100)][mColGridY - (k * 100)].setDisplayedIcon(mInvaderFortBang01);
                                break;
                            case 22:
                                mFort[k - 1][mColGridX - (k * 100)][mColGridY - (k * 100)].setDisplayedIcon(mInvaderFortBang03);
                                break;
                            case 23:
                                mFort[k - 1][mColGridX - (k * 100)][mColGridY - (k * 100)].setDisplayedIcon(mInvaderFortBang11);
                                break;
                            case 24:
                                mFort[k - 1][mColGridX - (k * 100)][mColGridY - (k * 100)].setDisplayedIcon(mInvaderFortBang12);
                                break;
                            case 25:
                                mFort[k - 1][mColGridX - (k * 100)][mColGridY - (k * 100)].setDisplayedIcon(mInvaderFortBang21);
                                break;
                        }
/*                        if (mFort[k - 1][mColGridX - (k * 100)][mColGridY - (k * 100)].getRank() == 20) {
                            mFort[k - 1][mColGridX - (k * 100)][mColGridY - (k * 100)].setDisplayedIcon(mInvaderFortBang00);
                        } else if (mFort[k - 1][mColGridX - (k * 100)][mColGridY - (k * 100)].getRank() == 21) {
                            mFort[k - 1][mColGridX - (k * 100)][mColGridY - (k * 100)].setDisplayedIcon(mInvaderFortBang01);
                        } else if (mFort[k - 1][mColGridX - (k * 100)][mColGridY - (k * 100)].getRank() == 22) {
                            mFort[k - 1][mColGridX - (k * 100)][mColGridY - (k * 100)].setDisplayedIcon(mInvaderFortBang03);
                        } else if (mFort[k - 1][mColGridX - (k * 100)][mColGridY - (k * 100)].getRank() == 23) {
                            mFort[k - 1][mColGridX - (k * 100)][mColGridY - (k * 100)].setDisplayedIcon(mInvaderFortBang11);
                        } else if (mFort[k - 1][mColGridX - (k * 100)][mColGridY - (k * 100)].getRank() == 24) {
                            mFort[k - 1][mColGridX - (k * 100)][mColGridY - (k * 100)].setDisplayedIcon(mInvaderFortBang12);
                        } else if (mFort[k - 1][mColGridX - (k * 100)][mColGridY - (k * 100)].getRank() == 25) {
                            mFort[k - 1][mColGridX - (k * 100)][mColGridY - (k * 100)].setDisplayedIcon(mInvaderFortBang21);
                        }*/
                        mFort[k - 1][mColGridX - (k * 100)][mColGridY - (k * 100)].setLastDisplayed(2);
                    } else if (mFort[k - 1][mColGridX - (k * 100)][mColGridY - (k * 100)].getLastDisplayed() == 2) {
                        mFort[k - 1][mColGridX - (k * 100)][mColGridY - (k * 100)].setDisplayedIcon(mInvaderFortBangGone);
                        mFort[k - 1][mColGridX - (k * 100)][mColGridY - (k * 100)].setLastDisplayed(3);
                        // Reset the collision grid for that bit if fort
                        for (int x = 0; x < mInvaderFort00.getWidth() / 6; x++) {
                            for (int y = 0; y < mInvaderFort00.getHeight() / 6; y++) {
                                mCollisionGridX[x + mFort[k - 1][mColGridX - (k * 100)][mColGridY - (k * 100)].getPosX() / 6][y + mFort[k - 1][mColGridX - (k * 100)][mColGridY - (k * 100)].getPosY() / 6] = -1;
                                mCollisionGridY[x + mFort[k - 1][mColGridX - (k * 100)][mColGridY - (k * 100)].getPosX() / 6][y + mFort[k - 1][mColGridX - (k * 100)][mColGridY - (k * 100)].getPosY() / 6] = -1;
                        //Log.w("AC","X = " + x + mFort[k - 1][mColGridX - (k * 100)][mColGridY - (k * 100)].getPosX() / 6 + " Y = " + y + mFort[k - 1][mColGridX - (k * 100)][mColGridY - (k * 100)].getPosY() / 6);
                            }
                        }
                    }
                    mFire = false;
                    msInvaderBangID = mSoundPool.play(msInvaderBang, 1.0f, 1.0f, 1, 0, 1.0f);

                    // Have we hit the saucer?
                    } else if ((mColGridX == 1000) && (mColGridY == 1000)) {
                        mSaucer.setDisplayedIcon(mInvaderSaucerBang);
                        mSaucer.setLastDisplayed(2);
                        mSaucer.setHit(true);
                        mSaucer.setFlying(false);
                        mSaucer.setScore(50 * (int) ((mRando.nextFloat() * 3.5f + 1f)));
                        mSoundPool.stop(msSaucerID);
                        msSaucerBangID = mSoundPool.play(msSaucerBang, 1.0f, 1.0f, 1, 0, 1.0f);
                        mFire = false;
                    }
            }
        }
        mTimerSounds = mTimerSounds + secondsElapsed;
        if (mTimerSounds >= mTimerSoundsInterval) {
            mTimerSounds = 0;
            //mSoundPool.play(mFirstNoteSilent, 100, 100, 1, 0, 1.0f);
            if (mLastSound == 0){
                msFourthNoteID = mSoundPool.play(msFourthNote, 1.0f, 1.0f, 1, 0, 1.0f);
                mLastSound = 1;
            } else if (mLastSound == 3){
                msThirdNoteID = mSoundPool.play(msThirdNote, 1.0f, 1.0f, 1, 0, 1.0f);
                mLastSound = 0;
            } else if (mLastSound == 2){
                msSecondNoteID = mSoundPool.play(msSecondNote, 1.0f, 1.0f, 1, 0, 1.0f);
                mLastSound = 3;
            } else if (mLastSound == 1){
                msFirstNoteID = mSoundPool.play(msFirstNote, 1.0f, 1.0f, 1, 0, 1.0f);
                mLastSound = 2;
            }
        }

        // These comments are nonsense. I leave them in the code to give myself a laugh
        // The program doesn't have any timing currently, it is running flat out.
        // Movement right and left is controlled by this section
        // The icons are moved one at a time at a rate controlled by mTimerMoveInterval
        // Each time the interval is exceeded the PosX is updated. The sprite that is updated
        // is selected by mLastCol and mLastRow which cycle between mFirstOccupiedCol and
        // mLastOccupiedCol, and 4 to 0. This emulates the jerky updates in the original game
        //

        mTimerMoveLR = mTimerMoveLR + secondsElapsed;
        if ( mTimerMoveLR > mTimerMoveInterval){
            //Log.w("AC","mTimerMoveLR = " + mTimerMoveLR);
            mTimerMoveLR = 0f;
            if (mFire) {
                mShell.setPosY(mShell.getPosY() - mShellSpeed);
                if (mShell.getPosY() <= mPlayYOffset + 2 * mPlayCanvasHeight/15){
                    mFire = false;
                }
            }
            mTimerSaucer = mTimerSaucer + secondsElapsed;
            if ((!mSaucer.getFlying())){
//            if ((!mSaucerFlying)&&(!mSaucer.Hit)){
                // Saucer not flying has timer exceeded the random value
                if (mTimerSaucer > mTimerSaucerRandom){
                    // If so reset the timer and start flying
                    mTimerSaucer = 0f;
                    mSaucer.setFlying(true);
                    msSaucerID = mSoundPool.play(msSaucerFlightLong, 0.5f, 0.5f, 1, 2, 1.0f);
                }
            } else {
                // Reset the collision grid for the saucer
                if (mSaucer.getPosX() >=0){
                    for (int i = 0; i<mSaucer.DisplayedIcon.getWidth()/6; i++){
                        for (int j = 0; j<mSaucer.DisplayedIcon.getHeight()/6; j++){
                            mCollisionGridX[i + mSaucer.getPosX()/6][j + mSaucer.getPosY()/6] = -1;
                            mCollisionGridY[i + mSaucer.getPosX()/6][j + mSaucer.getPosY()/6] = -1;
                        }
                    }
                }
                // If saucer past far right stop flight and send back to start generate new random
                if (mSaucer.getPosX() >= mPlayCanvasWidth){
//                    mSaucer.setPosX(-(mSaucerSpeed + mSaucer.getDisplayedIcon().getWidth()));
                    mSaucer.setPosX(-(mSaucer.getDisplayedIcon().getWidth()));
                    mTimerSaucer = 0f;
                    // Saucer random timer is between 15 and 30 seconds
                    mTimerSaucerRandom = ((mRando.nextFloat()*15) + 15);
                    mSaucer.setFlying(false);
                    mSoundPool.stop(msSaucerID);

                } else {
                    // Otherwise increment flying position and set collision grid for saucer
                    mSaucer.setPosX(mSaucer.getPosX() + mSaucerSpeed);
                    if (mSaucer.getPosX() >=0){
                        for (int i = 0; i<mSaucer.getDisplayedIcon().getWidth()/6; i++){
                            for (int j = 0; j<mSaucer.getDisplayedIcon().getHeight()/6; j++){
                                mCollisionGridX[i + mSaucer.getPosX()/6][j + mSaucer.getPosY()/6] = 1000;
                                mCollisionGridY[i + mSaucer.getPosX()/6][j + mSaucer.getPosY()/6] = 1000;
                            }
                        }
                    }
                }

            }

            for (int i = 0; i < mNumberOfBombs; i++) {
                if (mBombs[i].getFired()) {
                    mBombs[i].setPosY(mBombs[i].getPosY() + mBombSpeed);
                    int temprank = mBombs[i].getRank();
                    if (mBombs[i].getLastDisplayed() == 1) {
//                        if (mBombs[i].getRank() == 10) {
                        if (temprank == 10) {
                            mBombs[i].setDisplayedIcon(mInvaderBomb12);
                        } else if (temprank == 11) {
                            mBombs[i].setDisplayedIcon(mInvaderBomb22);
                        } else if (temprank == 12) {
                            mBombs[i].setDisplayedIcon(mInvaderBomb32);
                        }
                        mBombs[i].setLastDisplayed(2);
                    } else if (mBombs[i].getLastDisplayed() == 2) {
                        if (temprank == 10) {
                            mBombs[i].setDisplayedIcon(mInvaderBomb13);
                        } else if (temprank == 11) {
                            mBombs[i].setDisplayedIcon(mInvaderBomb23);
                        } else if (temprank == 12) {
                            mBombs[i].setDisplayedIcon(mInvaderBomb33);
                        }
                        mBombs[i].setLastDisplayed(3);
                    } else if (mBombs[i].getLastDisplayed() == 3) {
                        if (temprank == 10) {
                            mBombs[i].setDisplayedIcon(mInvaderBomb14);
                        } else if (temprank == 11) {
                            mBombs[i].setDisplayedIcon(mInvaderBomb24);
                        } else if (temprank == 12) {
                            mBombs[i].setDisplayedIcon(mInvaderBomb34);
                        }
                        mBombs[i].setLastDisplayed(4);

                    } else if (mBombs[i].getLastDisplayed() == 4) {
                        if (temprank == 10) {
                            mBombs[i].setDisplayedIcon(mInvaderBomb11);
                        } else if (temprank == 11) {
                            mBombs[i].setDisplayedIcon(mInvaderBomb21);
                        } else if (temprank == 12) {
                            mBombs[i].setDisplayedIcon(mInvaderBomb31);
                        }
                        mBombs[i].setLastDisplayed(1);
                    }

                }
                if (mBombs[i].getPosY() > (mPlayYOffset + (14 * mPlayCanvasHeight)/15)) {
                    mBombs[i].setDisplayedIcon(mInvaderBombGone);
                    mBombs[i].setFired(false);
                }
                if(mBombs[i].getFired() && mCollisionGridX[mBombs[i].getPosX()/6][mBombs[i].getPosY()/6] != -1 ) {
                    int mColGridX = mCollisionGridX[mBombs[i].getPosX() / 6][mBombs[i].getPosY() / 6];
                    int mColGridY = mCollisionGridY[mBombs[i].getPosX() / 6][mBombs[i].getPosY() / 6];
                    if ((mColGridX >= 100 && mColGridX < 1000) && (mColGridY >= 100 && mColGridY < 1000)) {
                        int k = ((mColGridX) / 100);
                        if (mFort[k - 1][mColGridX - (k * 100)][mColGridY - (k * 100)].getLastDisplayed() == 1) {
                            switch (mFort[k - 1][mColGridX - (k * 100)][mColGridY - (k * 100)].getRank()){
                                case 20:
                                    mFort[k - 1][mColGridX - (k * 100)][mColGridY - (k * 100)].setDisplayedIcon(mInvaderFortBang00);
                                    break;
                                case 21:
                                    mFort[k - 1][mColGridX - (k * 100)][mColGridY - (k * 100)].setDisplayedIcon(mInvaderFortBang01);
                                    break;
                                case 22:
                                    mFort[k - 1][mColGridX - (k * 100)][mColGridY - (k * 100)].setDisplayedIcon(mInvaderFortBang03);
                                    break;
                                case 23:
                                    mFort[k - 1][mColGridX - (k * 100)][mColGridY - (k * 100)].setDisplayedIcon(mInvaderFortBang11);
                                    break;
                                case 24:
                                    mFort[k - 1][mColGridX - (k * 100)][mColGridY - (k * 100)].setDisplayedIcon(mInvaderFortBang12);
                                    break;
                                case 25:
                                    mFort[k - 1][mColGridX - (k * 100)][mColGridY - (k * 100)].setDisplayedIcon(mInvaderFortBang21);
                                    break;
                            }

                            mFort[k - 1][mColGridX - (k * 100)][mColGridY - (k * 100)].setLastDisplayed(2);
                        } else if (mFort[k - 1][mColGridX - (k * 100)][mColGridY - (k * 100)].getLastDisplayed() == 2) {
                            mFort[k - 1][mColGridX - (k * 100)][mColGridY - (k * 100)].setDisplayedIcon(mInvaderFortBangGone);
                            mFort[k - 1][mColGridX - (k * 100)][mColGridY - (k * 100)].setLastDisplayed(3);
                            // Reset the collision grid for that bit if fort
                            for (int x = 0; x < mInvaderFort00.getWidth() / 6; x++) {
                                for (int y = 0; y < mInvaderFort00.getHeight() / 6; y++) {
                                    mCollisionGridX[x + mFort[k - 1][mColGridX - (k * 100)][mColGridY - (k * 100)].getPosX() / 6][y + mFort[k - 1][mColGridX - (k * 100)][mColGridY - (k * 100)].getPosY() / 6] = -1;
                                    mCollisionGridY[x + mFort[k - 1][mColGridX - (k * 100)][mColGridY - (k * 100)].getPosX() / 6][y + mFort[k - 1][mColGridX - (k * 100)][mColGridY - (k * 100)].getPosY() / 6] = -1;
                                }
                            }
                        }
                        mBombs[i].setFired(false);
                    }
                    if ((mColGridX == 1100) && (mColGridY == 1100)) { // Hit the turret
                        mTurret.setHit(true);
                        mTurret.setDisplayedIcon(mInvaderTurretGone);
                        msExplosionID = mSoundPool.play(msExplosion, 1.0f, 1.0f, 1, 0, 1.0f);
                        mTurret.setLastDisplayed(2);
                    }
                }

            }


            mLastCol = mLastCol + 1;
            if(mLastCol > mLastOccupiedCol) {
                mLastCol = mFirstOccupiedCol;
                mLastRow = mLastRow - 1;
            }
            if(mLastRow <= -1) {
                mLastRow = 4;
                if (mDownOne){
                    mDownOne = false;
                    mYPosIncrement = mYPosStep;
                }
                else{
                    mYPosIncrement = 0;
                }
            }
            // Speeds up the sounds as the game speeds up
            mTimerSoundsInterval = 1/4f + (float)(mLastOccupiedCol - mFirstOccupiedCol)/15f;

// If Gone move the Saucer back to the start
            if (mSaucer.isGone()){
                mSaucer.setDisplayedIcon(mInvaderSaucer);
                mSaucer.setLastDisplayed(1);
//                mSaucer.setPosX( -(mSaucerSpeed + mSaucer.getDisplayedIcon().getWidth()));
                mSaucer.setPosX( -mSaucer.getDisplayedIcon().getWidth());
                mTimerSaucer = 0f;
                mTimerSaucerRandom = (mRando.nextFloat()*15 + 15);
                mSaucer.setFlying(false);
                mSaucer.setHit(false);
                mSaucer.setGone(false);
            }

// If Hit Reset the collision grid and flash the Saucer
            if (mSaucer.isHit()){
                // Reset the collision grid for the saucer
                if (mSaucer.getPosX() >=0){
                    for (int i = 0; i<mSaucer.DisplayedIcon.getWidth()/6; i++){
                        for (int j = 0; j<mSaucer.DisplayedIcon.getHeight()/6; j++){
                            mCollisionGridX[i + mSaucer.getPosX()/6][j + mSaucer.getPosY()/6] = -1;
                            mCollisionGridY[i + mSaucer.getPosX()/6][j + mSaucer.getPosY()/6] = -1;
                        }
                    }
                }

                //mSaucer.DisplayedIcon = mInvaderSaucerBangGone;
                if ( ((mSaucer.getLastDisplayed()/4) % 3) == 0) {
                    mSaucer.setDisplayedIcon(mInvaderSaucerGang);
                } else if (((mSaucer.getLastDisplayed()/4) % 2) ==0){
                    mSaucer.setDisplayedIcon(mInvaderSaucerBang);
                } else {
                    mSaucer.setDisplayedIcon(mInvaderSaucerSang);
                }
                mSaucer.setLastDisplayed(mSaucer.getLastDisplayed() + 1);
//                mSaucerFlying = false;
                mSaucer.setFlying(false);
                if (mSaucer.LastDisplayed >= 100) {
                    if (mSaucer.getScore() == 50){
                        mSaucer.setDisplayedIcon(mInvaderSaucerScore050);
                    } else if (mSaucer.getScore() == 100){
                        mSaucer.setDisplayedIcon(mInvaderSaucerScore100);
                    }else if (mSaucer.getScore() == 150){
                        mSaucer.setDisplayedIcon(mInvaderSaucerScore150);
                    }else if (mSaucer.getScore() == 200){
                        mSaucer.setDisplayedIcon(mInvaderSaucerScore200);
                    }
                }
                if (mSaucer.LastDisplayed >= 200) {
                    //updateScore(mSaucer.Score);
                    mScore += mSaucer.getScore();
                    //UpdateLocalScore(mPlayer, mScore);
                    mSaucer.setGone(true);
                    mSaucer.setLastDisplayed(3);
                }
            }
// If Hit Reset the collision grid and flash the Turret
            if (mTurret.isHit()){
                // Reset the collision grid for the Turret
                if (mTurret.getPosX() >=0){
                    for (int i = 0; i<mTurret.DisplayedIcon.getWidth()/6; i++){
                        for (int j = 0; j<mTurret.DisplayedIcon.getHeight()/6; j++){
                            mCollisionGridX[i + mTurret.getPosX()/6][j + mTurret.getPosY()/6] = -1;
                            mCollisionGridY[i + mTurret.getPosX()/6][j + mTurret.getPosY()/6] = -1;
                        }
                    }
                }

                //mTurret.DisplayedIcon = mInvaderTurretBangGone;
                if ( ((mTurret.LastDisplayed/4) % 3) == 0) {
                    mTurret.DisplayedIcon = mInvaderTurretGone;
                } else if (((mTurret.getLastDisplayed()/4) % 2) ==0){
                    mTurret.setDisplayedIcon(mInvaderTurretBang1);
                } else {
                    mTurret.setDisplayedIcon(mInvaderTurretBang2);
                }
                mTurret.LastDisplayed += 1;
                if (mTurret.getLastDisplayed() >= 100) {
                    mTurret.setHit(false);
                    mTurret.setGone(false);
                    mTurret.setDisplayedIcon(mInvaderTurret);
                    mTurret.setLastDisplayed(1);
                    mNumberOfLives = mNumberOfLives -1;
                    if(mNumberOfLives == -1){mNumberOfLives = 3;}
                    mTurret.setPosX(mPlayXOffset + (mPlayCanvasWidth / 2));
                    mTurret.setPosY((13 * mPlayCanvasHeight) /15);
                    for (int i = 0; i<mTurret.getDisplayedIcon().getWidth()/6; i++){
                        for (int j = 0; j<mTurret.getDisplayedIcon().getHeight()/6; j++){
                            mCollisionGridX[i + mTurret.getPosX()/6][j + mTurret.getPosY()/6] = 1100;
                            mCollisionGridY[i + mTurret.getPosX()/6][j + mTurret.getPosY()/6] = 1100;
                        }
                    }

                }
                if(mNumberOfLives <= 0 && !mDebugMode){
                    endGame();
                    // setState(GameThread.STATE_LOSE);
                }
            }
// If Hit blank the Invader
            if (mSprites[mLastCol][mLastRow].isHit()){
                mSprites[mLastCol][mLastRow].setDisplayedIcon(mInvaderBangGone);
                mSprites[mLastCol][mLastRow].setLastDisplayed(4);
                mSprites[mLastCol][mLastRow].setRank(9);
                mSprites[mLastCol][mLastRow].setGone(true);
            }

            /* Check to see if end columns are empty (all invaders in the column have been Hit) if so
            increment mFirstOccupiedCol or decrement mLastOccupiedCol (this code is brilliant!)
            First check that we are at first column and the lowest row
            */
            //Log.w("AC","Before FirstCol = " + mFirstOccupiedCol + "Before LastCol = " + mLastOccupiedCol);

            if (mLastCol==mFirstOccupiedCol && mLastRow==4) {
                int mCount = 0;
                // int mEscape = 0;
                while (mSprites[mFirstOccupiedCol][mCount].isHit()) {
                // while (mSprites[mFirstOccupiedCol][mCount].Hit && mEscape < 54) {
                    if (mSprites[mFirstOccupiedCol][mCount].getLastDisplayed() ==3)
                    {
                        mSprites[mFirstOccupiedCol][mCount].setDisplayedIcon(mInvaderBangGone);
                        mSprites[mFirstOccupiedCol][mCount].setLastDisplayed(4);
                    }
                    mCount++;
                    // mEscape++;
                    if (mCount == 4) {
                        mFirstOccupiedCol++;
                        mCount = 0;
                    }
                }
                mCount = 0;
                while (mSprites[mLastOccupiedCol][mCount].isHit()) {
                    mCount++;
                    if (mCount == 4) {
                        mLastOccupiedCol--;
                        mCount = 0;
                    }
                }
                //if (mEscape >= 54){setState(GameThread.STATE_WIN);}
                mLastCol = mFirstOccupiedCol;
            }
            //Log.w("AC","After FirstCol = " + mFirstOccupiedCol + "After LastCol = " + mLastOccupiedCol);
// fred
            if (mScore >= 200) {
                mNumberOfBombsInUse = 2;
            }
            if (mScore>=500) {
                mNumberOfBombsInUse = 3;
            }
            if (mScore>=1000) {
                mNumberOfBombsInUse = 4;
            }
            for (int i=0; i < mNumberOfBombsInUse; i++) {
                if (!mBombs[i].isFired()) { // Fire a bomb
                    // Which sprite is the bomber?
                    int mSpriteBomberCol = (int) ((float) mFirstOccupiedCol + ((float) mLastOccupiedCol + 1 - (float) mFirstOccupiedCol) * mRando.nextFloat());
                    // Which bomb type 10..12
                    mBombRank = (int) (10f + (3f * mRando.nextFloat()));
                    //Log.w("AC","mBombRank = " + mBombRank);
                    // Find last un-hit Sprite in the column (maybe need to move to next column if all hit)
                    int mCount = 0;
                    while (mSprites[mSpriteBomberCol][mCount].isHit()) {
                        mCount++;
                        if (mCount == 4) {
                            mSpriteBomberCol++;
                            // Potential here for an infinite loop if no un-hit invader found
                            if (mSpriteBomberCol > 10){
                                mSpriteBomberCol = 0;
                            }
                            mCount = 0;
                        }
                    }

                    int mLastUnHit = 0;
                    for (int x = 0; x < 4; x++) {
                        if (!mSprites[mSpriteBomberCol][x].isHit()) {
                            mLastUnHit = x;
                        }
                    }

                    // Drop a bomb from the middle of the sprite's bum
                    mBombs[i].setPosX(mSprites[mSpriteBomberCol][mLastUnHit].getPosX() + mSprites[mSpriteBomberCol][mLastUnHit].getDisplayedIcon().getWidth() / 2);
                    mBombs[i].setPosY(mSprites[mSpriteBomberCol][mLastUnHit].getPosY() + mSprites[mSpriteBomberCol][mLastUnHit].getDisplayedIcon().getHeight());
                    mBombs[i].setRank(mBombRank);
                    if (mBombs[i].getRank() == 10) {
                        mBombs[i].setDisplayedIcon(mInvaderBomb11);
                    } else if (mBombs[i].getRank() == 11) {
                        mBombs[i].setDisplayedIcon(mInvaderBomb21);
                    } else if (mBombs[i].getRank() == 12) {
                        mBombs[i].setDisplayedIcon(mInvaderBomb31);
                    }
                    mBombs[i].setLastDisplayed(1);
                    mBombs[i].setFired(true);
                }

            }

            // Before updating the sprite position reset the collision grid to -1 at the last known position for this sprite
            int mThisSpriteWidth = mSprites[mLastCol][mLastRow].getDisplayedIcon().getWidth()/6;
            int mThisSpriteHeight = mSprites[mLastCol][mLastRow].getDisplayedIcon().getHeight()/6;
            int mThisSpritePosX = mSprites[mLastCol][mLastRow].getPosX();
            int mThisSpritePosY = mSprites[mLastCol][mLastRow].getPosY();
            for (int i = 0 ; i < mThisSpriteWidth; i++) {
                for (int j = 0; j < mThisSpriteHeight; j++) {
                    mCollisionGridX[i + mThisSpritePosX / 6][j + mThisSpritePosY / 6] = -1;
                    mCollisionGridY[i + mThisSpritePosX / 6][j + mThisSpritePosY / 6] = -1;
                }
            }
            // Update the position (X&Y) of the sprite and flip the icon for the sprite rank
            // based on the LastDisplayed
            mSprites[mLastCol][mLastRow].setPosX(mSprites[mLastCol][mLastRow].getPosX() + mXPosIncrement);
            mSprites[mLastCol][mLastRow].setPosY(mSprites[mLastCol][mLastRow].getPosY() + mYPosIncrement);
            if (mSprites[mLastCol][mLastRow].getLastDisplayed() == 1) {
                switch (mSprites[mLastCol][mLastRow].getRank()) {
                    case 0:
                        mSprites[mLastCol][mLastRow].setDisplayedIcon(mInvaderRank12);
                        break;
                    case 1:
                        mSprites[mLastCol][mLastRow].setDisplayedIcon(mInvaderRank22);
                        break;
                    case 2:
                        mSprites[mLastCol][mLastRow].setDisplayedIcon(mInvaderRank32);
                        break;
                }
                mSprites[mLastCol][mLastRow].setLastDisplayed(2);
            } else {
                switch (mSprites[mLastCol][mLastRow].getRank()) {
                    case 0:
                        mSprites[mLastCol][mLastRow].setDisplayedIcon(mInvaderRank11);
                        break;
                    case 1:
                        mSprites[mLastCol][mLastRow].setDisplayedIcon(mInvaderRank21);
                        break;
                    case 2:
                        mSprites[mLastCol][mLastRow].setDisplayedIcon(mInvaderRank31);
                        break;
                }
                mSprites[mLastCol][mLastRow].setLastDisplayed(1);

/*
                if (mSprites[mLastCol][mLastRow].getRank() == 0)
                    mSprites[mLastCol][mLastRow].setDisplayedIcon(mInvaderRank12);
                if (mSprites[mLastCol][mLastRow].getRank() == 1)
                    mSprites[mLastCol][mLastRow].setDisplayedIcon(mInvaderRank22);
                if (mSprites[mLastCol][mLastRow].getRank() == 2)
                    mSprites[mLastCol][mLastRow].setDisplayedIcon(mInvaderRank32);

            } else {
                if (mSprites[mLastCol][mLastRow].getRank() == 0) mSprites[mLastCol][mLastRow].setDisplayedIcon(mInvaderRank11);
                if (mSprites[mLastCol][mLastRow].getRank() == 1) mSprites[mLastCol][mLastRow].setDisplayedIcon(mInvaderRank21);
                if (mSprites[mLastCol][mLastRow].getRank() == 2) mSprites[mLastCol][mLastRow].setDisplayedIcon(mInvaderRank31);
                mSprites[mLastCol][mLastRow].setLastDisplayed(1);
            }
*/
            }
            // if the sprite has not been hit update the collision grid with the current location
            if (!mSprites[mLastCol][mLastRow].isHit()) {
                for (int i = 0; i < mSprites[mLastCol][mLastRow].getDisplayedIcon().getWidth()/6; i++) {
                    for (int j = 0; j < mSprites[mLastCol][mLastRow].getDisplayedIcon().getHeight() / 6; j++) {
                        //Log.w("AC","mLastCol = " + mLastCol + " mLastRow = " + mLastRow + " mLastCol = " + mLastCol + " getWidth = " + (mSprites[mLastCol][mLastRow].getDisplayedIcon().getWidth()/6) + " getHeight = " + (mSprites[mLastCol][mLastRow].getDisplayedIcon().getHeight()/6));
                        mCollisionGridX[i + mSprites[mLastCol][mLastRow].getPosX() / 6][j + mSprites[mLastCol][mLastRow].getPosY() / 6] = mLastCol;
                        mCollisionGridY[i + mSprites[mLastCol][mLastRow].getPosX() / 6][j + mSprites[mLastCol][mLastRow].getPosY() / 6] = mLastRow;
                    }
                }
            }

        }
        if (mPreviousScore != mScore){
            UpdateLocalScore(mPlayer, mScore);
            mPreviousScore = mScore;
        }
    }


}

// The game created in this file is original work by Andrew Chisholm
// It is based on a canvas provided by the course "Begin Programming"
// provided by the University of Reading through FutureLearn; their
// original copyright notice is included below
// Copyright: Andrew Chisholm
// It is free software: you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.
//
// It is is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
//
// You should have received a copy of the GNU General Public License
// along with it.  If not, see <http://www.gnu.org/licenses/>.



// This file is part of the course "Begin Programming: Build your first mobile game" from futurelearn.com
// Copyright: University of Reading and Karsten Lundqvist
// It is free software: you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.
//
// It is is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
//
// You should have received a copy of the GNU General Public License
// along with it.  If not, see <http://www.gnu.org/licenses/>.
